zoukankan      html  css  js  c++  java
  • poj 3169&hdu3592(差分约束)

    Layout
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 9687   Accepted: 4647

    Description

    Like everyone else, cows like to stand close to their friends when queuing for feed. FJ has N (2 <= N <= 1,000) cows numbered 1..N standing along a straight line waiting for feed. The cows are standing in the same order as they are numbered, and since they can be rather pushy, it is possible that two or more cows can line up at exactly the same location (that is, if we think of each cow as being located at some coordinate on a number line, then it is possible for two or more cows to share the same coordinate).

    Some cows like each other and want to be within a certain distance of each other in line. Some really dislike each other and want to be separated by at least a certain distance. A list of ML (1 <= ML <= 10,000) constraints describes which cows like each other and the maximum distance by which they may be separated; a subsequent list of MD constraints (1 <= MD <= 10,000) tells which cows dislike each other and the minimum distance by which they must be separated.

    Your job is to compute, if possible, the maximum possible distance between cow 1 and cow N that satisfies the distance constraints.

    Input

    Line 1: Three space-separated integers: N, ML, and MD.

    Lines 2..ML+1: Each line contains three space-separated positive integers: A, B, and D, with 1 <= A < B <= N. Cows A and B must be at most D (1 <= D <= 1,000,000) apart.

    Lines ML+2..ML+MD+1: Each line contains three space-separated positive integers: A, B, and D, with 1 <= A < B <= N. Cows A and B must be at least D (1 <= D <= 1,000,000) apart.

    Output

    Line 1: A single integer. If no line-up is possible, output -1. If cows 1 and N can be arbitrarily far apart, output -2. Otherwise output the greatest possible distance between cows 1 and N.

    Sample Input

    4 2 1
    1 3 10
    2 4 20
    2 3 3

    Sample Output

    27

    Hint

    Explanation of the sample:

    There are 4 cows. Cows #1 and #3 must be no more than 10 units apart, cows #2 and #4 must be no more than 20 units apart, and cows #2 and #3 dislike each other and must be no fewer than 3 units apart.

    The best layout, in terms of coordinates on a number line, is to put cow #1 at 0, cow #2 at 7, cow #3 at 10, and cow #4 at 27.
     
    第一次接触真的很难弄好..
    附上某大牛的解说:
     N个人编号为1-N,并且按照编号顺序排成一条直线,任何两个人的位置不重合,然后给定一些约束条件。
           X(X <= 100000)组约束Ax Bx Cx(1 <= Ax < Bx <= N),表示Ax和Bx的距离不能大于Cx。
           Y(X <= 100000)组约束Ay By Cy(1 <= Ay < By <= N),表示Ay和By的距离不能小于Cy。
           如果这样的排列存在,输出1-N这两个人的最长可能距离,如果不存在,输出-1,如果无限长输出-2。
          像这类问题,N个人的位置在一条直线上呈线性排列,某两个人的位置满足某些约束条件,最后要求第一个人和最后一个人的最长可能距离,这种是最直白的差分约束问题,因为可以用距离作为变量列出不等式组,然后再转化成图求最短路。
          令第x个人的位置为d[x](不妨设d[x]为x的递增函数,即随着x的增大,d[x]的位置朝着x正方向延伸)。
          那么我们可以列出一些约束条件如下:
          1、对于所有的Ax Bx Cx,有 d[Bx] - d[Ax] <= Cx;
          2、对于所有的Ay By Cy,有 d[By] - d[Ay] >= Cy;
          3、然后根据我们的设定,有 d[x] >= d[x-1] + 1 (1 < x <= N)  (这个条件是表示任何两个人的位置不重合)
         而我们需要求的是d[N] - d[1]的最大值,即表示成d[N] - d[1] <= T,要求的就是这个T。
         于是我们将所有的不等式都转化成d[x] - d[y] <= z的形式,如下:
          1、d[Bx]  -  d[Ax]    <=    Cx
          2、d[Ay]  -  d[By]    <=  -Cy
          3、d[x-1] -    d[x]    <=    -1
         对于d[x] - d[y] <= z,令z = w(y, x),那么有 d[x] <= d[y] + w(y, x),所以当d[x] > d[y] + w(y, x),我们需要更新d[x]的值,这对应了最短路的松弛操作,于是问题转化成了求1到N的最短路。
           对于所有满足d[x] - d[y] <= z的不等式,从y向x建立一条权值为z的有向边。
          然后从起点1出发,利用SPFA求到各个点的最短路,如果1到N不可达,说明最短路(即上文中的T)无限长,输出-2。如果某个点进入队列大于等于N次, 则必定存在一条负环,即没有最短路,输出-1。否则T就等于1到N的最短路。
    #include <stdio.h>
    #include <algorithm>
    #include <string.h>
    #include <iostream>
    #include <stdlib.h>
    #include <queue>
    using namespace std;
    const int M = 20005;
    const int N = 1005;
    const int INF = 99999999;
    struct Edge{
        int v,w,next;
    }edge[M];
    int head[N];
    int n;
    bool vis[N];
    int time[N],low[N];
    int spfa(int s){
        queue<int> q;
        for(int i=1;i<=n;i++){
            vis[i] = false;
            low[i] = INF;
            time[i] = 0;
        }
        low[s] = 0;
        time[s]++;
        q.push(s);
        while(!q.empty()){
            int u = q.front();
            q.pop();
            vis[u] = false;
            for(int k = head[u];k!=-1;k=edge[k].next){
                int v = edge[k].v,w = edge[k].w;
                if(low[v]>low[u]+w){
                    low[v] = low[u]+w;
                    if(!vis[v]){
                        vis[v] = true;
                        q.push(v);
                        if(time[v]++>n) return -1;
                    }
                }
            }
        }
        if(low[n]==INF) return -2;
        return low[n];
    }
    void addEdge(int u,int v,int w,int &k){
        edge[k].v = v,edge[k].w = w,edge[k].next = head[u],head[u]=k++;
    }
    int main()
    {
        int ml,md;
        while(scanf("%d%d%d",&n,&ml,&md)!=EOF){
            memset(head,-1,sizeof(head));
            int u,v,w;
            int tot = 0;
            for(int i=0;i<ml;i++){
                scanf("%d%d%d",&u,&v,&w);
                addEdge(u,v,w,tot);
            }
              for(int i=0;i<md;i++){
                scanf("%d%d%d",&u,&v,&w);
                addEdge(v,u,-w,tot);
            }
            for(int i=1;i<n;i++){
                addEdge(i+1,i,-1,tot);
            }
            printf("%d
    ",spfa(1));
        }
    }

     hdu 3592

    #include <stdio.h>
    #include <algorithm>
    #include <string.h>
    #include <iostream>
    #include <stdlib.h>
    #include <queue>
    using namespace std;
    const int M = 20005;
    const int N = 1005;
    const int INF = 99999999;
    struct Edge
    {
        int v,w,next;
    } edge[M];
    int head[N];
    int n;
    bool vis[N];
    int time[N],low[N];
    int spfa(int s)
    {
        queue<int> q;
        for(int i=1; i<=n; i++)
        {
            vis[i] = false;
            low[i] = INF;
            time[i] = 0;
        }
        low[s] = 0;
        time[s]++;
        q.push(s);
        while(!q.empty())
        {
            int u = q.front();
            q.pop();
            vis[u] = false;
            for(int k = head[u]; k!=-1; k=edge[k].next)
            {
                int v = edge[k].v,w = edge[k].w;
                if(low[v]>low[u]+w)
                {
                    low[v] = low[u]+w;
                    if(!vis[v])
                    {
                        vis[v] = true;
                        q.push(v);
                        if(time[v]++>n) return -1;
                    }
                }
            }
        }
        if(low[n]==INF) return -2;
        return low[n];
    }
    void addEdge(int u,int v,int w,int &k)
    {
        edge[k].v = v,edge[k].w = w,edge[k].next = head[u],head[u]=k++;
    }
    int main()
    {
        int ml,md;
        int tcase;
        scanf("%d",&tcase);
        while(tcase--)
        {
            scanf("%d%d%d",&n,&ml,&md);
            memset(head,-1,sizeof(head));
            int u,v,w;
            int tot = 0;
            for(int i=0; i<ml; i++)
            {
                scanf("%d%d%d",&u,&v,&w);
                addEdge(u,v,w,tot);
            }
            for(int i=0; i<md; i++)
            {
                scanf("%d%d%d",&u,&v,&w);
                addEdge(v,u,-w,tot);
            }
            for(int i=1; i<n; i++)
            {
                addEdge(i+1,i,-1,tot);
            }
            printf("%d
    ",spfa(1));
        }
    }
  • 相关阅读:
    [转]Extundelete--数据恢复软件
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
    jQuery火箭图标返回顶部代码
  • 原文地址:https://www.cnblogs.com/liyinggang/p/5503234.html
Copyright © 2011-2022 走看看